﻿using System;
using System.Collections.Generic;
using System.Diagnostics.Contracts;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Derbster.Actions
{  
    [ContractClass(typeof(GameActionStackContract))]
    public interface IGameActionStack
    {
        int CurrentAction { get;  }
        List<IGameAction> Actions { get; }

        void Clear();
        void Push(IGameAction newAction);
        IGameAction Pop();
        void Redo();
        void Undo();
    }

    [ContractClassFor(typeof(IGameActionStack))]
    abstract class GameActionStackContract : IGameActionStack
    {
        public int CurrentAction { get; set; }
        public List<IGameAction> Actions { get; set; }

        public void Clear()
        {
            Contract.Requires(Actions != null);
            throw new NotImplementedException();
        }

        public void Push(IGameAction newAction)
        {
            Contract.Requires(newAction != null);
            throw new NotImplementedException();
        }

        public IGameAction Pop()
        {
            Contract.Requires(Actions.Count >= 1);
            throw new NotImplementedException();
        }

        public void Redo()
        {
            Contract.Requires(CurrentAction >= 0);
            Contract.Requires(Actions.Count >= 1);
            throw new NotImplementedException();
        }

        public void Undo()
        {
            Contract.Requires(CurrentAction > 0);
            Contract.Requires(Actions.Count >= 1);
            throw new NotImplementedException();
        }
    }
}
