﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Diagnostics.Contracts;
using System.Linq;
using System.Text;

namespace Derbster.Domain
{
    public class BoxEvent
    {
        [ContractVerification(false)]
        internal BoxEvent()
        {

        }

        public BoxEvent(Skater skater, bool wasSeated, bool wasReleased, int period, int jamNumber, int pass)
        {
            Contract.Requires(skater != null);
            Contract.Requires(wasSeated || wasReleased);
            Contract.Requires(wasSeated != wasReleased);

            if (wasSeated)
            {
                this.Seated = true;
                this.Released = false;
            }
            else
            {
                this.Released = true;
                this.Seated = false;
            }


            Skater = skater;
            Period = period;
            JamNumber = jamNumber;
            Pass = pass;
        }
        public Match Match { get; set; }
        public Skater Skater { get; set; }

        public int Period { get; set; }
        public int JamNumber { get; set; }
        public int Pass { get; set; }

        public bool Seated { get; set; }
        public bool Released { get; set; }

        [Key, DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public int BoxEventId { get; set; }
    }
}
