﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Diagnostics.Contracts;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Derbster.Domain
{
    public class League
    {
        [ContractVerification(false)]
        internal League()
        {
            
        }

        public League(string name)
        {
            Contract.Requires(!string.IsNullOrWhiteSpace(name));
            Name = name;
            Teams = new HashSet<Team>();
            Officials = new HashSet<Official>();
        }

        [Key]
        public string LeagueId { get; set; }
        public string Name { get; set; }
        public HashSet<Team> Teams { get; set; }
        public HashSet<Official> Officials { get; set; }  
    }
}
