﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Diagnostics.Contracts;
using System.Linq;
using System.Text;

namespace Derbster.Domain
{
    public class Scoring
    {
        public bool Lost { get; set; }
        public bool Lead { get; set; }
        public bool NoPass { get; set; }
        public bool Called { get; set; }
        public bool Injury { get; set; }

        public bool StarPassed { get; set; }
        public int? StarPassedDuringPass { get; set; }

        public HashSet<ScoringPass> Passes { get; set; }
        public Skater Jammer { get; set; }

        [Key, DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public int ScoringId {get; set;}

        [ContractVerification(false)]
        internal Scoring()
        {
            
        }

        public Scoring(Skater jammer)
        {
            Contract.Requires(jammer != null);
            Contract.Ensures(Passes != null);

            Jammer = jammer;
            Passes = new HashSet<ScoringPass>();
        }
    }
}
