﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Diagnostics.Contracts;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Derbster.Domain
{
    public class ScoringPass
    {
        [ContractVerification(false)]
        internal ScoringPass()
        {
            
        }

        public ScoringPass(int pass, int score)
        {
            Contract.Requires(pass >= 1);
            Contract.Requires(score >= 0 && score <= 6);
            Pass = pass;
            Score = score;
        }
        public int Pass { get; set; }
        public int Score { get; set; }

        [Key, DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public int ScoringPassId {get; set;}

        public Scoring Scoring { get; set; }
    }
}
