﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Diagnostics.Contracts;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Derbster.Domain
{
    public class Team
    {
        [ContractVerification(false)]
        internal Team()
        {
            
        }

        public Team(string name)
        {
            Contract.Requires(!string.IsNullOrWhiteSpace(name));
            Contract.Requires(name.Length > 0);

            Name = name;
            Skaters = new HashSet<Skater>();
        }

        [Key]
        public string TeamId { get; set; }
        public string Name { get; set; }
        public League League { get; set; }

        public HashSet<Skater> Skaters { get; set; }
    }
}
