﻿using System;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Collections.Generic;
using Derbster.Actions;
using Derbster.DataAccess;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Derbster.Tests
{
    using System.Data.Entity;

    /// <summary>
    /// Summary description for GameTests
    /// </summary>
    [TestClass]
    public class GameTests
    {
        private IDerbsterContext _dbContext;
        private GameActionStack _actionStack;

        public GameTests()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext _testContextInstance;

        /// <summary>
        /// Gets or sets the test context which provides
        /// information about and functionality for the current test run.
        /// </summary>
        public TestContext TestContext
        {
            get
            {
                return this._testContextInstance;
            }
            set
            {
                this._testContextInstance = value;
            }
        }

        [TestInitialize]
        public void Setup()
        {
            _dbContext = new TestDerbsterContext();
            this._actionStack = new GameActionStack(_dbContext);
        }

        [TestMethod]
        public void TestGameSimulation()
        {
            Stopwatch timer = new Stopwatch();
            timer.Start();
          
            var simulator = new GameGenerator(_actionStack, _dbContext, .10);
            var match = simulator.SimulateMatch();
            Assert.IsTrue(match.VerifyMatch());
            timer.Stop();
            Assert.IsTrue(timer.ElapsedMilliseconds > 0);
            timer.Restart();
            using (var dbContext = new DerbsterContext())
            {
                var loadedMatch = dbContext.KnownMatches.SingleOrDefault(m => m.MatchId == match.MatchId);
                Assert.IsNotNull(loadedMatch);
                Assert.IsTrue(match.VerifyMatch());
                dbContext.KnownMatches.Remove(loadedMatch);
            }
            timer.Stop();
            Assert.IsTrue(timer.ElapsedMilliseconds > 0);

        }
    }
}
