﻿using System;
using System.Linq;
using Derbster.Actions;
using Derbster.DataAccess;
using Derbster.Domain;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Derbster.Tests
{
    
    [TestClass]
    public class ManagementActionTests
    {
        private DerbsterContext _dbContext;
        private GameActionStack _actionStack;
        [TestInitialize]
        public void Setup()
        {
            _dbContext =new DerbsterContext();
            _actionStack = new GameActionStack(_dbContext);
        }
        [TestMethod]
        public void TestMethodSkater()
        {
            var managementActions = new PersonManagementActions(_dbContext,_actionStack);
            var skater = managementActions.CreateSkater("Testing Skater", "ICU7");
            Assert.IsNotNull(skater);
            Assert.IsNotNull(skater.SkaterId);
            var skaterId = skater.SkaterId;
            _actionStack.Undo();

            using (var dbContext = new DerbsterContext())
            {
                Assert.IsFalse(dbContext.KnownSkaters.Any(s => s.SkaterId == skaterId));
                _actionStack.Redo();
                Assert.IsTrue(dbContext.KnownSkaters.Any(s => s.SkaterId == skaterId));
                managementActions.DeleteSkater(skater);
            }
        }
    }
}
